ColorGradingEditorSliderElement = {}

local ColorGradingEditorSliderElement_mt = Class(ColorGradingEditorSliderElement, SliderElement)

function ColorGradingEditorSliderElement.new(target, custom_mt)
	local self = SliderElement.new(target, custom_mt or ColorGradingEditorSliderElement_mt)

	return self
end

function ColorGradingEditorSliderElement:loadFromXML(xmlFile, key)
	ColorGradingEditorSliderElement:superClass().loadFromXML(self, xmlFile, key)

	self:addCallback(xmlFile, key .. "#onMiddleClick", "onMiddleClickCallback")
end

function ColorGradingEditorSliderElement:copyAttributes(src)
	ColorGradingEditorSliderElement:superClass().copyAttributes(self, src)

	self.onMiddleClickCallback = src.onMiddleClickCallback
end

function ColorGradingEditorSliderElement:mouseEvent(posX, posY, isDown, isUp, button, eventUsed)
	if self:getIsActive() then
		if ColorGradingEditorSliderElement:superClass().mouseEvent(self, posX, posY, isDown, isUp, button, eventUsed) then
			eventUsed = true
		end

		if isDown and button == Input.MOUSE_BUTTON_MIDDLE and GuiUtils.checkOverlayOverlap(posX, posY, self.absPosition[1], self.absPosition[2], self.absSize[1], self.absSize[2]) then
			self:raiseCallback("onMiddleClickCallback", self)
		end
	end

	return eventUsed
end

function ColorGradingEditorSliderElement:callOnChanged()
	self:raiseCallback("onChangedCallback", self, self.currentValue)
end